package net;

import java.util.ArrayList;
import java.util.HashMap;

public class ConnectionHandler {

	private static HashMap<String, MessagesHandler> users = new HashMap<String, MessagesHandler>();
	public static boolean existUser(String username) {
		return users.containsKey(username);
	}
	
	public static void addUser(String username, MessagesHandler m) {
		users.put(username, m);
	}
	
	private static void clean() {
		ArrayList<String> tmp = new ArrayList<String>();
		for(String u : users.keySet()) {
			MessagesHandler m = users.get(u);
			if(!m.isActive())
				tmp.add(u);
		}
		for(String u : tmp) {
			users.remove(u);
		}
	}
	
	public static void sendMessage(String message) {
		clean();
		for(String u : users.keySet()) {
			MessagesHandler m = users.get(u);
			m.sendMessage(message);
		}
	}

	public static String listOfUsers() {
		ArrayList<String> tmp = new ArrayList<String>();
		for(String u : users.keySet()) {
			tmp.add(u);
		}
		return tmp.toString();
	}
}
