package net;

import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.Socket;

public class MessagesHandler extends Thread {

	private Socket socket;
	private ObjectInputStream in;
	private ObjectOutputStream out;
	
	public MessagesHandler(Socket socket) throws IOException {
		this.socket = socket;
		this.out = new ObjectOutputStream(socket.getOutputStream());
	}
	
	@Override
	public void run() {
		super.run();
		String username = null;
		try {
			this.in = new ObjectInputStream(socket.getInputStream());
			username = (String) in.readObject();			
			if(ConnectionHandler.existUser(username)) {
				sendMessage("Existing username. Bye!");
				out = null;
				socket.close();
				return;
			}
			ConnectionHandler.addUser(username, this);
			ConnectionHandler.sendMessage("[SERVER] " + username + " joined the chat.");
			sendMessage("[SERVER] Users: " + ConnectionHandler.listOfUsers());
			while(true) {
				String mess = (String) in.readObject();
				ConnectionHandler.sendMessage("["+username+"] " + mess);
			}
		} catch (Exception e) {
			if(username != null)
				ConnectionHandler.sendMessage("[SERVER] " + username + " left.");			
			out = null;
		}
	}
	
	public void sendMessage(String message) {
		if(out == null)
			return;
		try {
			out.writeObject(message);
			out.flush();
		} catch(IOException e) {			
		}
	}

	public boolean isActive() {
		if(out != null)
			return true;
		return false;
	}
}
